%ifndef A20_S
%define A20_S

bits	16

; ----------
; enable_a20
; Enables the A20 line via the Keyboard Controller
; ----------
enable_a20:
	cli
	pusha

	call	in_buffer_wait
	mov		al, 0xAD
	out		0x64, al
	
	call	in_buffer_wait
	mov		al, 0xD0
	out		0x64, al
	
	call	out_buffer_wait
	in		al, 0x60
	push	eax
	
	call	in_buffer_wait
	mov		al, 0xD1
	out		0x64, al
	
	call	in_buffer_wait
	pop		eax
	or		al, 2
	out		0x60, al
	
	call	in_buffer_wait
	mov		al, 0xAE
	out		0x60, al
	
	call	in_buffer_wait
	
	popa
	sti
	ret
	
in_buffer_wait:
	in		al, 0x64
	test	al, 2		; 00000010
	jnz		in_buffer_wait
	ret
	
out_buffer_wait:
	in		al, 0x64
	test	al, 1
	jz		out_buffer_wait
	ret


%endif