%ifndef GDT_S
%define GDT_S

bits	16

; Definitions
%define NULL_DESC	0x00
%define CODE_DESC	0x08
%define DATA_DESC	0x10

install_gdt:
	cli
	pusha
	
	lgdt	[gdt]
	
	popa
	sti
	ret
	
; -----------------------------
; Global Descriptor Table (GDT)
; -----------------------------
gdt_start:

gdt_null:					; Null GDT Descriptor
	dd		0x00000000
	dd		0x00000000
	
gdt_code:
	dw		0xFFFF
	dw		0x0000
	db		0x00
	db		10011010b		; Present | Ring 0 | Executable | Conforming | Readable
	db		11001111b		; Granularity | 32-Bit Mode
	db		0x00
	
gdt_data:
	dw		0xFFFF
	dw		0x0000
	db		0x00
	db		10010010b		; Present | Ring 0 | Data | Writable
	db		11001111b		; Granularity | 32-Bit Mode
	db		0x00
	
gdt_user_code:
	dw		0xFFFF
	dw		0x0000
	db		0x00
	db		11111010b
	db		11001111b
	db		0x00
	
gdt_user_data:
	dw		0xFFFF
	dw		0x0000
	db		0x00
	db		11110010b
	db		11001111b
	db		0x00
	
gdt_end:
gdt:
	dw		gdt_end - gdt_start - 1		; Size of GDT
	dd		gdt_start					; Location of GDT

%endif