%ifndef MULTIBOOT_S
%define MULTIBOOT_S

bits	16

struc multiboot_structure
	.flags				resd 1		; The flags describing what information is present
	.memory_low			resd 1		; The low dword of the available memory
	.memory_high		resd 1		; The high dword of the available memory
	.boot_device		resd 1		; The boot device ("root" partition)
	.cmd_line			resd 1		; The location of the kernel command line
	.mods_count			resd 1		; The boot-module count
	.mods_addr			resd 1		; The boot-module location
	.syms0				resd 1		; The symbol Table 0
	.syms1				resd 1		; The symbol Table 1
	.syms2				resd 1		; The symbol Table 2
	.mmap_length		resd 1		; The length of the memory map
	.mmap_addr			resd 1 		; The location of the memory map
	.drives_length		resd 1		; The drive info buffer length
	.drives_addr		resd 1 		; The drive info buffer location
	.config_table		resd 1		; The ROM Configuration Table
	.bootloader_name	resd 1		; The location to the bootloader name
	.apm_table			resd 1		; The APM table location
	.vbe_control_info	resd 1		; The VBE control info location
	.vbe_mode_info		resd 1		; The VBE mode info location
	.vbe_mode			resw 1		; The video mode
	.vbe_interface_seg	resw 1		; The VBE interface segment
	.vbe_interface_off	resw 1		; The VBE interface offset
	.vbe_interface_len	resw 1		; The VBE interface length
	
	; TODO: The rest deals with frame buffer and is not pertinant to what we
	; are going to do so far
	; I have excluded them for this reason, and will only include them when the time is right
	;.framebuffer_addr	resq 1
	;.framebuffer_pitch	resw 1
	;.framebuffer_width	resw 1
	;.framebuffer_height	resw 1
	;.framebuffer_bpp	resb 1
	;.framebuffer_type	resb 1
endstruc

%endif