#include "cpu.h"

uint8_t * get_cpu_vendor(void) {
	static uint32_t test[4] = {0};
	cpuid_string(0, test);
	
	return (uint8_t *)&test;
}

void cpuid(uint32_t code, uint32_t * a, uint32_t * d) {
	__asm__ volatile ("cpuid" : "=a"(*a), "=d"(*d) : "a"(code) : "ecx", "ebx");
}

uint32_t cpuid_string(uint32_t code, uint32_t where[4]) {
	__asm__ volatile ("cpuid" : "=b"(*where), "=c"(*(where+1)), "=d"(*(where+2)) : "a"(code));
	
	return (uint32_t)where[0];
}