#ifndef CPU_H
#define CPU_H

#include "util/types.h"

#define CPUID_VENDOR_OLDAMD			"AMDisbetter!"
#define CPUID_VENDOR_AMD			"AuthenticAMD"
#define CPUID_VENDOR_INTEL			"GenuineIntel"
#define CPUID_VENDOR_OLDTRANSMETA	"TransmetaCPU"
#define CPUID_VENDOR_TRANSMETA		"GenuineTMx86"
#define CPUID_VENDOR_CYRIX			"CyrixInstead"
#define CPUID_VENDOR_CENTAUR		"CentaurHauls"
#define CPUID_VENDOR_NEXGEN			"NexGenDriven"
#define CPUID_VENDOR_UMC			"UMC UMC UMC "
#define CPUID_VENDOR_SIS			"SiS SiS SiS "
#define CPUID_VENDOR_NSC			"Geode by NSC"
#define CPUID_VENDOR_RISE			"RiseRiseRise"
#define CPUID_VENDOR_VORTEX			"Vortex86 SoC"
#define CPUID_VENDOR_VIA			"VIA VIA VIA "

// Virtual Machines
#define CPUID_VENDOR_VMWARE			"VMwareVMware"
#define CPUID_VENDOR_XENHVM			"XenVMMXenVMM"
#define CPUID_VENDOR_MICROSOFT_HV	"Microsoft HV"
#define CPUID_VENDOR_PARALLELS		" lrpepyh vr"

uint8_t * get_cpu_vendor(void);

void cpuid(uint32_t code, uint32_t * a, uint32_t * d);
uint32_t cpuid_string(uint32_t code, uint32_t where[4]);

#endif