#ifndef GDT_H
#define GDT_H

#include "util/types.h"

#pragma pack (push, 1)
struct gdt_entry {
	uint16_t 	limit_low;
	uint16_t	base_low;
	uint8_t		base_middle;
	uint8_t		access;
	uint8_t		granularity;
	uint8_t		base_high;
};
typedef struct gdt_entry gdt_entry_t;
#pragma pack (pop)

#pragma pack (push, 1)
struct gdt_ptr {
	uint16_t	size;
	uint32_t	base;
};
typedef struct gdt_ptr gdt_ptr_t;
#pragma pack (pop)

void gdt_init(void);
void gdt_set_gate(uint32_t gate, uint32_t base, uint32_t limit, uint8_t access, uint8_t granularity);

extern void gdt_flush(uint32_t gdt);

#endif