#ifndef IDT_H
#define IDT_H

#include "util/types.h"	

#pragma pack (push, 1)
typedef struct {
	uint16_t	base_low;
	uint16_t	selector;
	uint8_t		reserved;
	uint8_t 	attribute;
	uint16_t	base_high;
} idt_entry_t;
#pragma pack (pop)

#pragma pack (push, 1)
typedef struct {
	uint16_t	size;
	uint32_t	base;
} idt_ptr_t;
#pragma pack (pop)

void idt_init(void);
void idt_set_gate(uint32_t gate, uint32_t base, uint16_t selector, uint8_t attribute);

extern void idt_flush(uint32_t idt);

#endif