bits	32
jmp		kernel_entry

struc multiboot_header_structure
	.magic		resd 1
	.flags		resd 1
	.checksum	resd 1
endstruc

; Constants
MULTIBOOT_FLAGS		equ 10b
MULTIBOOT_MAGIC		equ 0x1BADB002
MULTIBOOT_CHECKSUM	equ -(MULTIBOOT_MAGIC + MULTIBOOT_FLAGS)

; The multiboot header
align	4
multiboot_header:
istruc multiboot_header_structure
	at multiboot_header_structure.magic,	dd MULTIBOOT_MAGIC
	at multiboot_header_structure.flags,	dd MULTIBOOT_FLAGS
	at multiboot_header_structure.checksum,	dd MULTIBOOT_CHECKSUM
iend

kernel_entry:
	; EAX is 2BADB002
	; EBX is the location of the multiboot structure
	; EDX is the size of the kernel in sectors
	mov		cx, 0x10
	mov		ds, cx
	mov		es, cx
	mov		fs, cx
	mov		gs, cx
	mov		ss, cx
	
	mov		esp, 0x600000
	
	; Push EBX
	push	ebx
	
	extern	main
	call	main 

	cli
	hlt