#ifndef PMM_H
#define PMM_H

#include "util/types.h"

#define PMM_BLOCKS_PER_BYTE	8
#define PMM_BLOCK_SIZE		4096
#define PMM_BLOCK_ALIGN		PMM_BLOCK_SIZE

// Physical Memory Manager
void pmm_init(uint32_t size, uint32_t bitmap);

// Regions
void pmm_init_region(uint32_t base, size_t size);
void pmm_deinit_region(uint32_t base, size_t size);

// Blocks
void * pmm_alloc_block(void);
void pmm_free_block(void * p);

void * pmm_alloc_blocks(size_t size);
void pmm_free_blocks(void * p, size_t size);

// PMM Bitmap
void pmm_bitmap_set(uint32_t bit);
void pmm_bitmap_clear(uint32_t bit);
uint32_t pmm_bitmap_test(uint32_t bit);

uint32_t pmm_first_free(void);
uint32_t pmm_first_free_s(size_t size);

#endif