#ifndef PIC_H
#define PIC_H

#include "util/types.h"

// Ports
#define PIC1			0x20
#define PIC2			0xA0
#define PIC1_COMMAND	0x20
#define PIC1_DATA		0x21
#define PIC2_COMMAND	0xA0
#define PIC2_DATA		0xA1

// Command Word 1
#define ICW1_ICW4		0x01
#define ICW1_SINGLE		0x02
#define ICW1_INTERVAL4	0x04
#define ICW1_LEVEL		0x08
#define ICW1_INIT		0x10

// Command Word 4
#define ICW4_8086		0x01
#define ICW4_AUTO		0x02
#define ICW4_BUF_SLAVE	0x08
#define ICW4_BUF_MASTER	0x0C
#define ICW4_SFNM		0x10

// Functions
void pic_init(void);
void pic_remap_irqs(void);
void pic_send_eoi(uint8_t irq);

// IRQ Masks
void irq_set_mask(uint8_t irq);
void irq_clear_mask(uint8_t irq);


#endif