#include "pit.h"
#include "util/util.h"

static uint64_t pit_ticks = 0;

void pit_init(uint32_t frequency) {
	
	uint32_t divisor = 1193180 / frequency;
	outportb(0x43, 0x36);
	
	uint8_t low = (uint8_t)(divisor & 0xFF);
	uint8_t high = (uint8_t)((divisor >> 8) & 0xFF);
	
	outportb(0x40, low);
	outportb(0x40, high);
}

void pit_update(void) {
	pit_ticks++;
}

uint64_t pit_get_tick(void) {
	return pit_ticks;
}