#ifndef REGISTERS_H
#define REGISTERS_H

#include "util/types.h"

typedef struct {
	
	uint32_t 	gs, fs, es, ds;							// The four main segment registers
	uint32_t	edi, esi, ebp, ebx, edx, ecx, eax;		// The 7 data registers
	uint32_t 	int_no, err_code;						// The interrupt number and error code
	uint32_t 	eip, cs, eflags, esp, ss;				// The return EIP, CS, EFLAGS, stack pointer (esp) and ss segment
	
} __attribute__((packed)) registers_t;

#endif