#ifndef ARGS_H
#define ARGS_H

#include "types.h"

// This is mostly for variable arguments (va) but it can
// contain other useful defines and functions for function
// arguments

#define STACKITEM int		// The width of each stack item is the width on an int on the system

// This rounds up the width of the objects pushed onto the stack. The expression before the & insures
// that we get 0 for objects of size 0
#define VA_SIZE(TYPE) ((sizeof(TYPE) + sizeof(STACKITEM) - 1) & ~(sizeof(STACKITEM) - 1))

// &(LASTARG) points to the LEFTMOST argument of the function call (before the ...)
#define va_start(AP, LASTARG) (AP=((va_list)&(LASTARG) + VA_SIZE(LASTARG)))

// Do nothing for va_end
#define va_end(AP)

// The arguments
#define va_arg(AP, TYPE) (AP += VA_SIZE(TYPE), *((TYPE *)(AP - VA_SIZE(TYPE))))


#endif