#include "util.h"

// Memory

uint8_t * memcpy(uint8_t * dest, const uint8_t * src, size_t len) {
	for (; len != 0; len--) {
		*dest++ = *src++;
	}
	
	return dest;
}

uint8_t * memset(uint8_t * dest, uint8_t val, size_t len) {
	for (; len != 0; len--) {
		*dest++ = val;
	}
	
	return dest;
}

// Strings

size_t strlen(const char * str) {
	size_t len = 0;
	for (; *str != 0x00; str++, len++);
	
	return len;
}

char * strcpy(char * dest, const char * src) {
	char * save = dest;
	while ((*dest++ = *src++));
	return save;
}

// Conversion

char tbuf[32];
char bchars[] = {'0', '1', '2', '3', '4', '5', '6', '7', '8', '9', 'A', 'B', 'C', 'D', 'E', 'F'};

void uitoa(unsigned int i, char * buf, int base) {
	int pos = 0;
	int opos = 0;
	int top = 0;
	
	if (i == 0 || base > 16) {
		buf[0] = '0';
		buf[1] = '\0';
		return;
	}
	
	while (i != 0) {
		tbuf[pos] = bchars[i % base];
		pos++;
		i /= base;
	}
	
	top = pos--;
	for (opos = 0; opos < top; pos--, opos++) {
		buf[opos] = tbuf[pos];
	}
	
	buf[opos] = 0;
}

void itoa(int i, char * buf, int base) {
	if (base > 16) return;
	if (i < 0) {
		*buf++ = '-';
		i *= -1;
	}
	uitoa(i, buf, base);
}


// I/O Commands
char inportb(uint16_t port) {
	uint8_t ret;
	__asm__ volatile ("inb %1, %0" : "=a"(ret) : "dN"(port));
	return ret;
}

void outportb(uint16_t port, char data) {
	__asm__ volatile ("outb %1, %0" :: "dN"(port), "a"(data));
}