#ifndef UTIL_H
#define UTIL_H

#include "types.h"

// This file contains useful functions for strings, memory, and some basic
// assembly functions (such as read/write I/O commands)

// Memory
uint8_t * memcpy(uint8_t * dest, const uint8_t * src, size_t len);
uint8_t * memset(uint8_t * dest, uint8_t val, size_t len);

// Strings
size_t strlen(const char * str);
char * strcpy(char * dest, const char * src);

// Conversion
void uitoa(unsigned int i, char * buf, int base);
void itoa(int i, char * buf, int base);

// I/O Commands
char inportb(uint16_t port);

void outportb(uint16_t port, char data);

#endif